//--------------------------------------------------------------//
// Killstreaks.cs						//
//--------------------------------------------------------------//

//--------------------------------------------------------------//
// Variables				    			//
//--------------------------------------------------------------//
$Killstreak::Message[3]    	= "Killing Spree";
$Killstreak::Message[4]    	= "Killing Streak";
$Killstreak::Message[5]    	= "Killing Frenzy";
$Killstreak::Message[6]    	= "Rampage";
$Killstreak::Message[7]		= "Destroying";
$Killstreak::Message[8]  	= "Massacre";
$Killstreak::Message[9]  	= "Slaughter";
$Killstreak::Message[10] 	= "Executioner";
$Killstreak::Message[11] 	= "Carnage";
$Killstreak::Message[12] 	= "War Crime";
$Killstreak::Message[13] 	= "Homicide";
$Killstreak::Message[14] 	= "Bloodshed";
$Killstreak::Message[15] 	= "Annihilation";
$Killstreak::Message[16] 	= "Genocide";
$Killstreak::Message[17] 	= "Godly";

$Killstreak::Overkill[1]  	= "Impervious";
$Killstreak::Overkill[2]  	= "Unobtainable";
$Killstreak::Overkill[3]  	= "Impossible";
$Killstreak::Overkill[4]  	= "Overkill";
$Killstreak::Overkill[5]  	= "Extermination";
$Killstreak::Overkill[6]  	= "Reaper";
$Killstreak::Overkill[7]  	= "God of war";
$Killstreak::Overkill[8]  	= "Killtacular";
$Killstreak::Overkill[9]  	= "Killtrocity";
$Killstreak::Overkill[10] 	= "Killtastrophe";
$Killstreak::Overkill[11] 	= "Killpocalypse";
$Killstreak::Overkill[12] 	= "Killionaire";
$Killstreak::Overkill[13] 	= "Divine";
$Killstreak::Overkill[14] 	= "Invincible";
$Killstreak::Overkill[15] 	= "Untouchable";

$Killstreak::MultiKill[2]	= "Double-Kill";
$Killstreak::MultiKill[3]	= "Triple-Kill";
$Killstreak::MultiKill[4]	= "Multi-Kill";
$Killstreak::MultiKill[5]	= "Ultra-Kill";
$Killstreak::MultiKill[6]	= "Monster-Kill";

$Killstreak::CanOverlapMsg 	= 0;
$Killstreak::HasSpawned 	= 0;
$Killstreak::GlobalKills	= 0;

//----Start Package------
package Swol_KillStreaks
{
//--------------------------------------------------------------//
// Disable Other Killstreak Mods				//
//--------------------------------------------------------------//
	function GameConnection::OnClientEnterGame(%this)
	{
		Parent::OnClientEnterGame(%this);
		if(!$Killstreak::HasSpawned)
		{
			$Killstreak::HasSpawned = 1;
			Killstreak_DisableCrap();
		}
		return;
	}

	function Killstreak_DisableCrap()
	{
		//----These mods cause glitches and are basically their own killstreak mod 
		//----so we need to disable them, we can do this when the first person on the server spawns
		//----This way we make sure they have all been executed before we disable them

		//----Tomtom's killstreaks
		deactivatepackage(Killstreaks);
		//----Cucumberdude's killstreaks
		deactivatepackage(Rewards);
		//----The Geek's killstreaks
		deactivatepackage(TG_NewRewards);
	}
//--------------------------------------------------------------//
// Death function						//
//--------------------------------------------------------------//
	function gameConnection::onDeath(%killed, %killerPlayer, %killer, %a, %b)
	{
		parent::onDeath(%killed, %killerPlayer, %killer, %a, %b);
		if(!$Killstreak::Enabled)
		return;
	//----Whoops! your dead!
		if(!isObject(%Killer.Player))
		return %Killer.kills = 0;
		if(%Killer == %Killed)
		{
			KillStreakDeathMsg(%Killed,%Killed.kills,13,0,0);
			%Killed.Kills = 0;
			%Killed.MultiKills = 0;
			cancel(%Killer.MultiKillSched);
			cancel(%Killed.KillStrkMsgSched);
			%killed.KsMsg = 0;
			return;
		}
		$Killstreak::GlobalKills++;
	//----Killer
		%killer.Kills++;
		%killer.MultiKills++;
		%killer.Domination[%Killed]++;
	//----Killed
		KillStreakDeathMsg(%Killed,%Killed.kills,13,0,%Killer);
		%killed.kills = 0;
		%killed.MultiKills = 0;
		cancel(%Killed.KillStrkMsgSched);
		%killed.KsMsg = 0;

		GenerateKs(%Killer,%Killed,%Killer.Kills);
	}
//--------------------------------------------------------------//
// Generate Killstreaks, Dominations, Revenges, and MultiKills	//
//--------------------------------------------------------------//
	function GenerateKS(%Killer,%Killed,%Kills)
	{
		if(!isObject(%Killer.Player))
		return %Killer.kills = 0;
		cancel(%Killer.MultiKillSched);
	//----Revenge
		if(%killed.Domination[%Killer] > 2)
		{
			%DomKillerMsg = "\c3You claimed revenge on \c6" @ %Killed.name;
			%DomKilledMsg = "\c6" @ %Killer.name @ "\c3 claimed revenge on you";
			DominationRevenge(%Killer,%Killed,%DomKillerMsg,%DomKilledMsg);
			%Killed.Domination[%Killer] = 0;
		}
	//----Domination
		if(%killer.Domination[%Killed] == 3)
		{
			%DomKillerMsg = "\c3You are dominating \c6" @ %Killed.name;
			%DomKilledMsg = "\c6" @ %Killer.name @ "\c3 is dominating you";
			DominationRevenge(%Killer,%Killed,%DomKillerMsg,%DomKilledMsg);
		}
	//----Multi Kills
		if(%Killer.MultiKills > 1)
		{
			if(%Killer.MultiKills > 6)
			%Killer.MultiKills = 6;
			%MultiKillMsg = $Killstreak::MultiKill[%Killer.MultiKills] @ "! ";
		}
		%Killer.MultiKillSched = Schedule(2000,0,ClearMultiKill,%Killer);
	//----Multi Kills without killstreak
		if(%Kills < 3)
		{
			if(%Killer.MultiKills > 1)
			{
				KillStreakMsg(%Killer,%Killed,1,1,40,%MultiKillMsg);
				return;
			} else {
				return;
			}
		}
	//----Figure out the killstreak title
		if(%Kills <= 17)
		{
			%KsTitle = $Killstreak::Message[%Kills];
		} else {
			%Rand = getRandom(1,15);
			if(%Killer.lastkillmsg == %Rand)
			{
				if(%Rand < 15)
				%Rand += 1;
				else
				%Rand = 1;
			}
			%Killer.lastkillmsg = %Rand;
			%KsTitle = $Killstreak::Overkill[%Rand];
		}
		if($Killstreak::ChatMsg)
		MessageAll('',"<bitmap:base/client/ui/ci/star> \c0[\c6" @ %Killer.name @ "\c0] \c3" @ %KsTitle @ " \c0[" @ %Kills @ " Kills]");

		%Msg = %KsTitle @ "! \c3(" @ %Kills @ ") ";
	//----Multi Kills with killstreak
		if(%Killer.MultiKills > 1)
		%Msg = %Msg NL %MultiKillMsg;

		KillStreakMsg(%Killer,%Killed,1,1,50,0,%Msg);

		%killed.Domination[%Killer] = 0;
	}
//--------------------------------------------------------------//
// Killstreak message						//
//--------------------------------------------------------------//
//----The killstreak messages pop up with a little animation
//--------------------------------------------------------------//

	function KillStreakMsg(%Client,%Killed,%FontSize,%FontGrow,%Tick,%Col,%Msg)
	{
		if(!isObject(%Client.Player))
		{
			%Client.KsMsg = 0;
			cancel(%Client.KillStrkMsgSched);
			return;
		}


		cancel(%Client.KillStrkMsgSched);
		%Client.KsMsg = 1;
		%Kills = %Client.kills;
	//----Killstreak messages get more bold as you get more kills
		if(%Kills < 10)
		{
			if(%FontSize < 40 && %FontGrow)
			{
				%FontSize += 6;
			} else {
				%FontGrow = 0;
				if(%FontSize > 35)
				%FontSize -= 2;
			}
		}
		if(%Kills >= 10 && %Kills < 20)
		{
			if(%FontSize < 50 && %FontGrow)
			{
				%FontSize += 6;
			} else {
				%FontGrow = 0;
				if(%FontSize > 45)
				%FontSize -= 2;
			}
		}
		if(%Kills >= 20)
		{
			if(%FontSize < 60 && %FontGrow)
			{
				%FontSize += 6;
			} else {
				%FontGrow = 0;
				if(%FontSize > 55)
				%FontSize -= 2;
			}
		}
		if(%Kills >= 30 && %Tick > 36)
		{
			if(!%Col)
			{
				%Col = 1;
			} else {
				if(%Col)
				%Col = 0;
				else
				%Col = 2;
			}
		}
		%Client.KsMsg = 0;
		if(!%Col)
		{
			%Client.CenterPrint("<br><br><br><br><just:right><font:impact:" @ %FontSize @ ">\c0" @ %Msg @ " ",1);
		} else {
			%Client.CenterPrint("<br><br><br><br><just:right><font:impact:" @ %FontSize @ ">\c3" @ %Msg @ " ",1);
		}
		%Client.KsMsg = 1;
		if(%tick > 0)
		{
			%tick--;
			%Client.KillStrkMsgSched = schedule(50,0,KillStreakMsg,%Client,%Killed,%FontSize,%FontGrow,%Tick,%Col,%Msg);
		} else {
			%Client.KsMsg = 0;
		}
	}
//--------------------------------------------------------------//
// Multi-Kills							//
//--------------------------------------------------------------//
	function ClearMultiKill(%Client)
	{
		if(%Client.MultiKills == 6 && $Killstreak::ChatMsg)
		{
			MessageAll('',"<bitmap:base/client/ui/ci/star> \c0[\c6" @ %Client.name @ "\c0] \c3Achieved a MONSTER KILL!");
		}
		%Client.MultiKills = 0;
	}
//--------------------------------------------------------------//
// Domination and Revenge					//
//--------------------------------------------------------------//
	function DominationRevenge(%Killer,%Killed,%MsgKiller,%MsgKilled)
	{
		MessageClient(%Killer,'',%MsgKiller);
		MessageClient(%Killed,'',%MsgKilled);
	}
//--------------------------------------------------------------//
// Killstreak Death Msg						//
//--------------------------------------------------------------//
//----Sort of a little "congrats" message for getting lots of kills
//--------------------------------------------------------------//
	function KillStreakDeathMsg(%Client,%Kills,%Tick,%Col,%Killer)
	{
		cancel(%Client.DeathMsgSched);
		if(%Kills < 15)
		return;

		if($Killstreak::ChatMsg && %Kills >= 40 && %Tick == 13)
		{
			if(%Killer != 0)
			MessageAll('',"<bitmap:base/client/ui/ci/star> \c0[\c6" @ %Client.name @ "\c0] \c3was killed by\c6" @ %Killer.name @ "\c3after achieving \c0" @ %Kills @ " Kills!");
			else
			MessageAll('',"<bitmap:base/client/ui/ci/star> \c0[\c6" @ %Client.name @ "\c0] \c3died after achieving \c0" @ %Kills @ " Kills!");
		}

		%FontSize = %Kills+10;
		if(%FontSize > 35)
		%FontSize = 35;
		
		if(%Kills > 25)
		{
			if(!%Col)
			{
				%Col = 1;
			} else {
				%Col = 0;
			}
		} else {
			if(%Killer != 0)
			BottomPrint(%Client,"<font:impact:" @ %FontSize @ ">\c3You were killed by\c0" @ %Killer.name @ "\c3after getting \c0" @ %Kills @ "\c3 Kills",3);
			else
			BottomPrint(%Client,"<font:impact:" @ %FontSize @ ">\c3You died after getting \c0" @ %Kills @ "\c3 Kills",3);
			return;
		}


		if(%Killer != 0)
		{
			if(!%Col)
			BottomPrint(%Client,"<font:impact:" @ %FontSize @ ">\c3You were killed by\c0" @ %Killer.name @ "\c3after achieving \c0" @ %Kills @ "\c3 Kills",1);
			if(%Col)
			BottomPrint(%Client,"<font:impact:" @ %FontSize @ ">\c0You were killed by\c3" @ %Killer.name @ "\c0after achieving \c3" @ %Kills @ "\c0 Kills",1);
		} else {
			if(!%Col)
			BottomPrint(%Client,"<font:impact:" @ %FontSize @ ">\c3You died after achieving \c0" @ %Kills @ "\c3 Kills",1);
			if(%Col)
			BottomPrint(%Client,"<font:impact:" @ %FontSize @ ">\c0You died after achieving \c3" @ %Kills @ "\c0 Kills",1);
		}

		if(%Tick > 0)
		{
			%Tick--;
			%Client.DeathMsgSched = Schedule(100,0,KillStreakDeathMsg,%Client,%Kills,%Tick,%Col,%Killer);
		}
	}
//--------------------------------------------------------------//
// Work-Arounds							//
//--------------------------------------------------------------//
//----Prevent killstreak messages from being overlapped
//--------------------------------------------------------------//
	function GameConnection::CenterPrint(%Client,%A,%B,%C)
	{
		if(!$Killstreak::CanOverlapMsg)
		{
			if(%Client.KsMsg)
			return;
		}
		return parent::CenterPrint(%Client,%A,%B,%C);
	}
};
ActivatePackage(Swol_KillStreaks);
//----Stop Package-------